const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const projects = sequelize.define(
    'projects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      project_name: {
        type: DataTypes.TEXT,
      },

      start_date: {
        type: DataTypes.DATE,
      },

      end_date: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  projects.associate = (db) => {
    db.projects.belongsToMany(db.tasks, {
      as: 'tasks',
      foreignKey: {
        name: 'projects_tasksId',
      },
      constraints: false,
      through: 'projectsTasksTasks',
    });

    db.projects.belongsToMany(db.tasks, {
      as: 'tasks_filter',
      foreignKey: {
        name: 'projects_tasksId',
      },
      constraints: false,
      through: 'projectsTasksTasks',
    });

    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.projects.hasMany(db.tasks, {
      as: 'tasks_project',
      foreignKey: {
        name: 'projectId',
      },
      constraints: false,
    });

    //end loop

    db.projects.belongsTo(db.companies, {
      as: 'companies',
      foreignKey: {
        name: 'companiesId',
      },
      constraints: false,
    });

    db.projects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.projects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return projects;
};
